/*********************************************************************
 *
 *      Example Binky LEDs
 *
 *********************************************************************
 * FileName:        blinky_leds.c
 * Dependencies:	plib.h
 *
 * Processor:       PIC32MX
 *
 * Complier:        MPLAB C32
 *                  MPLAB IDE
 * Company:         Microchip Technology Inc.
 *
 * Software License Agreement
 *
 * The software supplied herewith by Microchip Technology Incorporated
 * (the Company) for its PIC32MX Microcontroller is intended
 * and supplied to you, the Companys customer, for use solely and
 * exclusively on Microchip Microcontroller products.
 * The software is owned by the Company and/or its supplier, and is
 * protected under applicable copyright laws. All rights are reserved.
 * Any use in violation of the foregoing restrictions may subject the
 * user to criminal sanctions under applicable laws, as well as to
 * civil liability for the breach of the terms and conditions of this
 * license.
 *
 * THIS SOFTWARE IS PROVIDED IN AN AS IS CONDITION. NO WARRANTIES,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 *********************************************************************
 * $Id: blinky_leds.c 9390 2008-06-16 23:43:04Z rajbhartin $
 *
 * $Name:  $
 *********************************************************************
 * This program uses Exploer-16 to blink all of its LEDs at once.
 *
 * Platform: 	Explorer-16 with PIC32MX PIM
 *Modified for use with 32 bit Experimenter thk 11/7/10
 *modifed to test all pertinent I/o pins on EXP32 thk 11/21/10
 by setting all as ouputs and toggling them alterately
 PORTB	
RB0	JP3-1
RB1	JP3-2
RB2	JP3-3
RB3	JP3-4
RB4	JP2-8
RB5	JP2-7
RB8	JP4-8
RB9	BOT-1
RB10	BOT-2
RB11	L2
RB12	L1
RB13	BOT-8
RB14	BOT-3

PORTD	
RD0	JP2-3
RD1	BOT-7
RD2	JP2-1
RD3	JP2-2
RD4	JP4-2
RD6	TOP-10
RD7	TOP-9
RD8	JP2-4
RD9	BOT-5
RD10	JP4-1
RD11	BOT-6

PORTE	
RE0	TOP-6
RE1	TOP-5
RE2	TOP-4
RE3	TOP-3
RE4	TOP-2
RE5	JP2-5
RE6	JP2-6
RE7	TOP-1

PORTF	
RF0	TOP-8
RF1	TOP-7
RF3	BOT-4
RF4	JP3-5
RF5	JP3-6

PORTG	
RG6 	JP4-6
RG7	JP4-5
RG8	JP4-4
RG9	JP4-3



 ********************************************************************/
#include <plib.h>

// Configuration Bit settings
// SYSCLK = 80 MHz (8MHz Crystal/ FPLLIDIV * FPLLMUL / FPLLODIV)
// PBCLK = 40 MHz
// Primary Osc w/PLL (XT+,HS+,EC+PLL)
// WDT OFF
// Other options are don't care
//

#pragma config FNOSC = PRIPLL, POSCMOD = HS, FPLLIDIV = DIV_2, FPLLMUL = MUL_20, FPBDIV = DIV_2, FPLLODIV = DIV_1
#pragma config FWDTEN = OFF

#define	SYS_FREQ	80000000		// frequency we're running at
	int i=0;
void delay(void) {
	// Insert some delay
		i = 1024*1024;
		while(i--);
	
}	


int main(void)
{
	
	DDPCON=0x00;

    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	// Configure the device for maximum performance but do not change the PBDIV
	// Given the options, this function will change the flash wait states, RAM
	// wait state and enable prefetch cache but will not change the PBDIV.
	// The PBDIV value is already set via the pragma FPBDIV option above..
	SYSTEMConfig(SYS_FREQ, SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE);
	AD1PCFG = 0xFFFFFFFF;
//set appropiate bits of portb to output AND CLEAR
mPORTBClearBits(BIT_0|BIT_1|BIT_2|BIT_3|BIT_4|BIT_5|BIT_8|BIT_9|BIT_10|BIT_11|BIT_12|BIT_13|BIT_14);
mPORTBSetPinsDigitalOut(BIT_0|BIT_1|BIT_2|BIT_3|BIT_4|BIT_5|BIT_8|BIT_9|BIT_10|BIT_11|BIT_12|BIT_13|BIT_14);
//try to set very alternate bit so not all bits are on for toggle
	mPORTBSetBits(BIT_0|BIT_2|BIT_4|BIT_8|BIT_10|BIT_12|BIT_14);
	
//set appropiate bits of portd to output AND CLEAR
mPORTDClearBits(BIT_0|BIT_1|BIT_2|BIT_3|BIT_4|BIT_6|BIT_7|BIT_8|BIT_9|BIT_10|BIT_11);
mPORTDSetPinsDigitalOut(BIT_0|BIT_1|BIT_2|BIT_3|BIT_4|BIT_6|BIT_7|BIT_8|BIT_9|BIT_10|BIT_11);
//try to set very alternate bit so not all bits are on for toggle
	mPORTDSetBits(BIT_0|BIT_2|BIT_4|BIT_6|BIT_8|BIT_10);
	
//set appropiate bits of portE to output AND CLEAR
mPORTEClearBits(BIT_0|BIT_1|BIT_2|BIT_3|BIT_4|BIT_5|BIT_6|BIT_7);
mPORTESetPinsDigitalOut(BIT_0|BIT_1|BIT_2|BIT_3|BIT_4|BIT_5|BIT_6|BIT_7);
//try to set very alternate bit so not all bits are on for toggle
	mPORTESetBits(BIT_0|BIT_2|BIT_4|BIT_6);
	

//set appropiate bits of portF to output AND CLEAR
mPORTFClearBits(BIT_0|BIT_1|BIT_2|BIT_3|BIT_4|BIT_5);
mPORTFSetPinsDigitalOut(BIT_0|BIT_1|BIT_2|BIT_3|BIT_4|BIT_5);
//try to set very alternate bit so not all bits are on for toggle
	mPORTFSetBits(BIT_0|BIT_2|BIT_4);
	
//set appropiate bits of portg to output AND CLEAR
mPORTGClearBits(BIT_6|BIT_7|BIT_8|BIT_9);
mPORTGSetPinsDigitalOut(BIT_6|BIT_7|BIT_8|BIT_9);
//try to set very alternate bit so not all bits are on for toggle
	mPORTGSetBits(BIT_6|BIT_8);
	
	AD1PCFG = 0xFFFFFFFF;	
	// Now ALL OUTPUTS AND BLINK ledS ON/OFF forever.
	while(1)
	{
	//	mPORTBToggleBits(BIT_12 | BIT_11  );
mPORTBToggleBits(BIT_0|BIT_1|BIT_2|BIT_3|BIT_4|BIT_5|BIT_8|BIT_9|BIT_10|BIT_11|BIT_12|BIT_13|BIT_14);
mPORTDToggleBits(BIT_0|BIT_1|BIT_2|BIT_3|BIT_4|BIT_6|BIT_7|BIT_8|BIT_9|BIT_10|BIT_11);
mPORTEToggleBits(BIT_0|BIT_1|BIT_2|BIT_3|BIT_4|BIT_5|BIT_6|BIT_7);
mPORTFToggleBits(BIT_0|BIT_1|BIT_2|BIT_3|BIT_4|BIT_5);
mPORTGToggleBits(BIT_6|BIT_7|BIT_8|BIT_9);
	delay();
		
	}
}

